function add_query(has_filename=true)
{
    queryString = "plot=" + to_plot;
    if(has_filename){
        queryString += "&filename=" + filename;
    }
    return queryString
}

function full_with_query(has_filename=true)
{
    var queryString =  window.location.href.split('?')[0] + "?" + add_query(has_filename);
    return queryString
}

function to_plot_type(_)
{
    // sessionStore.setitem("to_plot", "bcid");
    to_plot = _
    var w = window.open( full_with_query(), "_top" )
}

urlParams = new URLSearchParams(window.location.search)
// qs = decodeURIComponent(window.location.search.substring(1));

// var queries = qs.split("&");
// for (var i = 0; i < queries.length; i++)
// {
  // document.write(queries[i] + "<br>");
  // var = queries[i].split()
// }
// var to_plot = qs.get("to_plot");;
var to_plot = urlParams.has("plot") ? urlParams.get('plot') : "null";
var filename = urlParams.has("filename") ? urlParams.get("filename") : "inputs/data_test.1562056881._nsw-stgc-180run0.daq.RAW._lb0000._ROX-1._0001_decoded.root";
// var to_plot = document.getElementById("to_plot<br>");
// var filename = document.getElementById("filename<br>");
// document.write(filename + "<br>");
// document.write(to_plot + "<br>");
// var filename = "inputs/data_test.1562056881._nsw-stgc-180run0.daq.RAW._lb0000._ROX-1._0001_decoded.root";

// document.ready(function() {
    // to_plot = sessionStore.getItem("to_plot");
    // var useremail = sessionStore.getItem("useremail");
    //("input_elem").val(useremail);
// });

// special handling for the amore::core::String_t which is redifinition of TString
// JSROOT.addUserStreamer("amore::core::String_t", "TString");

// register class and identify, that 'fVal' field should be used for drawing
// // one could specify explicit draw function, but it is not required in such simple case
// JSROOT.addDrawFunc({ name: "amore::core::MonitorObjectHisto<TH1F>", icon: "img_histo1d", draw_field: "fVal" });

function obj_treatment(obj)
{
    // line = JSROOT.createAttLine();
    // obj.inspect;

    var pad = document.getElementsByClassName("plot")[cnt]

    obj.fYaxis.fTitleOffset = 1.6;
    if (to_plot == "hit") 
    {
        obj.fXaxis.fTitle= "Channel + 64 #times vmmid";
        obj.fYaxis.fTitle= "Number of Hits";
        obj.fLineWidth = 1;

        // just a snippet of finding maximum
        var all_hit = true;
        var hit_count = 0;
        var expected = 256;
        for (var i in obj.fArray)
        {
            var n = obj.fArray[i]
            if (n < 1.)
                all_hit=false;
            else
                ++hit_count;
        }

        console.log(pad);

        if (all_hit){
            pad.style.backgroundColor = "green"
            // pad.style = ('background-color:green'); 
        }
        else if( hit_count / expected > 0.5) {
            pad.style.backgroundColor = "yellow"
        }
        else{
            pad.style.backgroundColor = "tomato"
            // pad.style = ('background-color:red'); 
        }
        
        var canvas = JSROOT.draw(pad, obj, "hist");

    // for (var i = 0; i < canvas.childNodes.length; i++) {
            // // document.write(canvas.childNodes[i].className)
            // var son = canvas.childNodes[i];
            // if(son.className = "jsroot root_canvas")
            // {
                // for (var j = 0; j < son.childNodes.length; j++) {
                // var gdson = son.childNodes[j];
                // if(gdson.className = "primitives_layer")
                // {
                    // break;
                // }
                // break;
            // }


            // }

        // }
        // console.log(canvas.querySelector("primitives_layer"))

        grs = []
        for (var i=1; i<8; ++i)
        {
            var npoints = 2
            var xpts = [i * 64 - 0.5, i * 64 - 0.5]
            // var ypts = [obj.fMinimum, obj.fMaximum]
            var ypts = [0, canvas.ymax]
            gr = JSROOT.CreateTGraph(npoints, xpts, ypts);
            gr.fLineColor = 2;
            gr.fLineWidth = 2;
            gr.fLineStyle = 2;
            // grs.push(gr);
            canvas = JSROOT.draw(pad, gr, "L");
        }

        var rf = document.getElementsByClassName("root_frame")[cnt];
        console.log(rf)
        rf.width = "300";
        rf.x = "60";
        rf.transform = "translate(60, 40)";

        // var mg = JSROOT.CreateTMultiGraph(grs[0], grs[1], grs[2], grs[3], grs[4], grs[5], grs[6]);


        // JSROOT.ShowInspector(mg)
        // b = JSROOT.TGraphPainter(mg)
        // b.ShowInspector()


        // a = JSROOT.draw(pad, grs[0], "L");

        // console.log(pad);
        console.log(canvas);
        cnt++
    }
}

if (to_plot != null)
{
    var plots = document.getElementById("allPlots")
    for (var i = 0; i < 100; ++i)
    {
        plot = document.createElement('div');
        plot.className = "plot";
        plot.id = "g" + i.toString();
        plot.style="width:400px; height:400px"
        plots.appendChild( plot );
    }
}

var cnt = 0;

if (to_plot == "hit") {

    JSROOT.OpenFile(filename, function(file) {
        console.log(file);

        file.ReadObject("Fiber0_FE1/noHits_vs_chan/NoHits_Vs_TotalChanNo_Fiber0_FE1", function(obj) 
            {
                obj_treatment(obj)
            });


        file.ReadObject("Fiber0_FE2/noHits_vs_chan/NoHits_Vs_TotalChanNo_Fiber0_FE2", function(obj) 
            {
                obj_treatment(obj)
            });
        file.ReadObject("Fiber0_FE3/noHits_vs_chan/NoHits_Vs_TotalChanNo_Fiber0_FE3", function(obj) 
            {
                obj_treatment(obj)
            });
    });
}

else if (to_plot == "bcid") {
    JSROOT.OpenFile(filename, function(file) {
        file.ReadObject("Fiber0_FE3/relbcid/Relbcid_Fiber0_FE3_vmmid7_chan61", function(obj) {
            obj_treatment(obj)
            // JSROOT.draw("g0", obj, "hist");
            });
        file.ReadObject("Fiber0_FE3/relbcid/Relbcid_Fiber0_FE3_vmmid7_chan62", function(obj) {
            // JSROOT.draw("g1", obj, "hist");
            obj_treatment(obj)
            });
        file.ReadObject("Fiber0_FE3/relbcid/Relbcid_Fiber0_FE3_vmmid7_chan63", function(obj) {
            // JSROOT.draw("g2", obj, "hist");
            obj_treatment(obj)
            });
    });
}



// Grid View
function gridView() {
    var elements = document.getElementsByClassName("column");
    for (var i = 0; i < elements.length; i++) {
        elements[i].style.width = "33%";
    }
}

//gridView()


// JSROOT.resize("g11");
// JSROOT.RegisterForResize('g11');
// JSROOT.resize(document.querySelector("#g11"), true);

$(document).ready(function(){
        $('a[href^="?"]').each(function(){ 
            var oldUrl = $(this).attr("href"); // Get current url
            // document.write(oldUrl+"<br>")
            var newUrl = oldUrl + "&" + add_query(false);
            // document.write(newUrl+"<br>")
            $(this).attr("href", newUrl); // Set herf value
        });
    });


    /* Optional: Add active class to the current button (highlight it) */
    var container = document.getElementById("btnContainer");
    var btns = container.getElementsByClassName("btn");
    for (var i = 0; i < btns.length; i++) {
      btns[i].addEventListener("click", function() {
        var current = document.getElementsByClassName("active");
        if (current.length > 0) {
            current[0].className = current[0].className.replace(" active", "");
        }
        this.className += " active";
      });
}


